# Ordenamiento circular
# Para python 3.7
# El ordenamiento viene descrito en:
# https://docs.python.org/3/howto/sorting.html#sortinghowto
# Fraga
# 04.03.2021
#
import numpy as np
import sys
import functools

n = len( sys.argv )
if n != 2 :
	print( "Args: archivo_puntos" )
	sys.exit(1)

nombre = sys.argv[1]

D = np.genfromtxt( nombre )

n, m = D.shape
print( n )

# Se busca el renglón (punto) con el mínimo y
yminInd = 0
i = 1
while i < n :
	if D[i,1] < D[ yminInd, 1] :
		yminInd = i
	i += 1

# Si hay varios puntos con y mínimo,
# buscamos el punto con x mínimo
xminInd = yminInd
i = 0
while i < n :
	if D[i,1] == D[ yminInd, 1] and D[i,0] < D[ xminInd, 0] :
		xminInd = i
	i += 1

print( D[xminInd,:] )

# Intercambiamos ese punto con el que está en el índice 0
if xminInd != 0 :
	tmp = D[0,0]
	D[0,0] = D[xminInd,0]
	D[xminInd,0] = tmp

	tmp = D[0,1]
	D[0,1] = D[xminInd,1]
	D[xminInd,1] = tmp

print( D )

def cmp( i, j ) :
	ux = D[0,0] - D[i,0]
	uy = D[0,1] - D[i,1]
	vx = D[j,0] - D[i,0]
	vy = D[j,1] - D[i,1]
	v = ux*vy - uy*vx
	if v > 0 :
		return 1;
	elif ( v < 0 ) :
		return -1
	else :
		d1 = ux*ux + uy*uy
		d2 = vx*vx + vy*vy
		if d1 < d2 :
			return 1
		else :
			return -1

va = list( range(1,n) )
va.sort(key=functools.cmp_to_key(cmp))

print(va)

